#!/usr/bin/perl -w
use strict;

my $can=$ARGV[0] // die "arg0 must be candev";
my $port=$ARGV[1];
my $extlogger="192.168.5.167";
    
sub print_run_or_die {
    my $cmdref = $_[0];
    my $ret;
    
    print "+ ", join(" ", @$cmdref) , "\n";
    $ret = system @$cmdref;
    if ( $ret != 0 ){
	if( $ret < 0 ){
	    print STDERR "tc.pl: failed to execute $cmdref->[0]: $!\n";
	    system("ls","-l",$cmdref->[0]);
	    system("ls","-lH",$cmdref->[0]);
	    system("size",$cmdref->[0]);
	    exit 255;
	} elsif( $ret & 0xff ){
	    fprintf STDERR "tc.pl killed (%d)", ($ret & 0x7f);
	    exit 254;
	}
	exit ($ret >> 8);
    }
}

my @std_args = (
    "./sctestself", 
    "-b", 
    "-n", "4" ,
    "-l", "999",
    "-t", "2",
    "-v", "cmperr,logmsg",
    "-F", "refilldata,leastdots,allowintloopb,stoponerror",
    );

if( defined($port) ){
    push @std_args, "-X", "$extlogger:$port";
}

print_run_or_die([@std_args, "-d", "8", $can]);
print_run_or_die([@std_args, "-d", "16", $can]);
print_run_or_die([@std_args, "-d", "24", $can]);
print_run_or_die([@std_args, "-d", "32", $can]);

